; by gargaj
; done on the plane to norway

%define TIMER fs:0x6C

bits 16 

org 0x100

mov ax, 13h
int 10h

inc cx
pal:
  mov al,cl
  mov dx,0x3c8
  out dx,al
  inc dx
  shr al,2
  or al,15
  out dx,al
  ror al,1
  out dx,al
  out dx,al
loop pal

push word 0a000h
pop es

push word 0x0040
pop fs

mainloop:
  xor di, di

  mov cx, 200
  loop_y:
    push cx
    mov bx, cx
    
    mov cx, 320
    loop_x:
      pushad
      xor si,si
      call roto
      popad
      inc di
    loop loop_x
    
    pop cx
  loop loop_y

  in al,0x60
  cmp al,1
jnz mainloop

ret

roto:
  inc si
  cmp si, 4
  jng noret
    ret
  noret:
  mov [x], cx
  mov [y], bx
  fild word [TIMER]     ; t
  fidiv word [slow]
  fsincos               ; cos(t)   sin(t)
  fld st1               ; sin(t)   cos(t)   sin(t)
  fimul word [y]        ; sin(t)*y cos(t)   sin(t)
  fld st1               ; cos(t)   sin(t)*y cos(t) sin(t)
  fimul word [x]        ; cos(t)*x sin(t)*y cos(t) sin(t)
  faddp st1             ; u        cos(t)   sin(t)
  fimul word [zoom]
  fistp word [u]        ; cos(t)   sin(t)

  fimul word [y]        ; cos(t)*y sin(t)
  fxch  st1             ; sin(t)   cos(t)*y
  fimul word [x]        ; sin(t)*x cos(t)*y
  fsubp st1             ; v
  fimul word [zoom]
  fistp word [v]        ; cos(t)   sin(t)
  
  mov cx, [u]
  mov bx, [v]

  mov al, cl
  add al, bl
  add al, 64

  cmp cl, 64  
  jg norecurse  
  cmp bl, 64  
  jg norecurse  
    call roto
    dec di
    shr al, 1
    add al, 16
  norecurse:
  stosb
ret

zoom dw 2
slow dw 200

section .bss

x resw 1
y resw 1
u resw 1
v resw 1